package edu.mermet.tp9.fenetres;

import javax.swing.*;
import javax.swing.filechooser.FileSystemView;
import java.awt.*;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

public class ConfigurationMenu extends JDialog {
    private String arg;
    private Properties properties;
    public ConfigurationMenu(String arg,Properties properties) {
        super();
        this.arg=arg;
        properties = properties;
        setTitle("Configuration des menus");
        init();
        pack();
        setVisible(true);
    }

    public void init() {
        this.properties = new Properties();

        this.setModal(true);
        getContentPane().setLayout(new BoxLayout(getContentPane(),BoxLayout.PAGE_AXIS));
        JPanel conversion = new JPanel();
        JPanel texte = new JPanel();
        JPanel diapo = new JPanel();
        JPanel btn = new JPanel();
        JPanel valid = new JPanel();

        JLabel texteConversion = new JLabel("Conversion Celsuis/Farenheit");
        JLabel saisieTexte = new JLabel("Saisie de texte");
        JLabel diaporama = new JLabel("Diaporama");
        JLabel boutons = new JLabel("Boutons");

        ButtonGroup group1 = new ButtonGroup();
        JRadioButton auto1 = new JRadioButton("Auto");
        auto1.setActionCommand("Auto");
        JRadioButton affiche1 = new JRadioButton("Affiché");
        affiche1.setActionCommand("Affiché");
        JRadioButton cache1 = new JRadioButton("Caché");
        cache1.setActionCommand("Caché");

        group1.add(auto1);
        group1.add(affiche1);
        group1.add(cache1);

        ButtonGroup group2 = new ButtonGroup();
        JRadioButton auto2 = new JRadioButton("Auto");
        auto2.setActionCommand("Auto");
        JRadioButton affiche2 = new JRadioButton("Affiché");
        affiche2.setActionCommand("Affiché");
        JRadioButton cache2 = new JRadioButton("Caché");
        cache2.setActionCommand("Caché");

        group2.add(auto2);
        group2.add(affiche2);
        group2.add(cache2);

        ButtonGroup group3 = new ButtonGroup();
        JRadioButton auto3 = new JRadioButton("Auto");
        auto3.setActionCommand("Auto");
        JRadioButton affiche3 = new JRadioButton("Affiché");
        affiche3.setActionCommand("Affiché");
        JRadioButton cache3 = new JRadioButton("Caché");
        cache3.setActionCommand("Caché");

        group3.add(auto3);
        group3.add(affiche3);
        group3.add(cache3);

        ButtonGroup group4 = new ButtonGroup();
        JRadioButton auto4 = new JRadioButton("Auto");
        auto4.setActionCommand("Auto");
        JRadioButton affiche4 = new JRadioButton("Affiché");
        affiche4.setActionCommand("Affiché");
        JRadioButton cache4 = new JRadioButton("Caché");
        cache4.setActionCommand("Caché");

        group4.add(auto4);
        group4.add(affiche4);
        group4.add(cache4);

        JButton valider = new JButton("Valider");
        valider.addActionListener(a->{

            System.out.println(group1.getSelection().getActionCommand());
            System.out.println(group2.getSelection().getActionCommand());
            System.out.println(group3.getSelection().getActionCommand());
            System.out.println(group4.getSelection().getActionCommand());
            properties.setProperty("conversion",group1.getSelection().getActionCommand());
            properties.setProperty("texte",group2.getSelection().getActionCommand());
            properties.setProperty("diaporama",group3.getSelection().getActionCommand());
            properties.setProperty("boutons",group4.getSelection().getActionCommand());

            try{
                File file;
                if(this.arg.equals("")){
                    file = new File(System.getProperty("user.home")+"/.ihm/"+System.getProperties().getProperty("user.name")+".xml");
                }else{
                    file = new File(System.getProperty("user.home")+"/.ihm/"+this.arg+".xml");
                }

                FileOutputStream fileOut = new FileOutputStream(file);
                properties.storeToXML(fileOut, "configuration");
                fileOut.close();
            } catch (IOException e) {
                e.printStackTrace();
            }

            dispose();
        });
        JButton annuler = new JButton("Annuler");

        conversion.add(texteConversion);
        conversion.add(auto1);
        conversion.add(affiche1);
        conversion.add(cache1);
        conversion.setLayout(new FlowLayout(FlowLayout.RIGHT));

        texte.add(saisieTexte);
        texte.add(auto2);
        texte.add(affiche2);
        texte.add(cache2);
        texte.setLayout(new FlowLayout(FlowLayout.RIGHT));

        diapo.add(diaporama);
        diapo.add(auto3);
        diapo.add(affiche3);
        diapo.add(cache3);
        diapo.setLayout(new FlowLayout(FlowLayout.RIGHT));


        btn.add(boutons);
        btn.add(auto4);
        btn.add(affiche4);
        btn.add(cache4);
        btn.setLayout(new FlowLayout(FlowLayout.RIGHT));

        valid.add(valider);
        valid.add(annuler);
        valid.setLayout(new FlowLayout(FlowLayout.CENTER));

        add(conversion);
        add(texte);
        add(diapo);
        add(btn);
        add(valid);
    }

    public Properties getProperties(){
        return this.properties;
    }
}
