package edu.mermet.tp9.fenetres;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.net.URL;
import javax.swing.*;

/**
 *
 * @author brunomermet
 */
public class FenetreConversion extends AbstractFenetreInterne {
    private JTextField champCelsius;
    private JTextField champFarenheit;
    private JButton boutonConvertir;
    private Action actionConvertir;
    private boolean celsiusAFocus;
    public FenetreConversion(Action action) {
        super(action,"Conversion celsius/Farenheit");
        this.setSize(new Dimension(100,50));
        this.setLayout(new GridLayout(3,1));
        JPanel ligneCelsius = new JPanel();
        ligneCelsius.setLayout(new FlowLayout(FlowLayout.TRAILING));
        JButton helpButtonCelsius = new JButton("?");
        try{
            helpButtonCelsius.setIcon((Icon) new ImageIcon(new URL
                    ("https://www.google.com/url?sa=i&url=https%3A%2F%2Fwww.iconfinder.com%2Ficons%2F438977%2Fhelp_information_" +
                            "problem_query_question_mark_status_support_icon&psig=AOvVaw1cYXbJ9Vzj3U5xdNUTgNYK&ust=1586010833844000&" +
                            "source=images&cd=vfe&ved=0CAIQjRxqFwoTCMidpfi8zOgCFQAAAAAdAAAAABAP")).getImage());
        }catch (Exception e){}


        helpButtonCelsius.addActionListener(a->{
            JFrame aide = new JFrame("Aide");
            JOptionPane.showMessageDialog(aide,"Valeur en degré Celsius");
        });

        JLabel labCelsius = new JLabel("Celsius :");
        labCelsius.setToolTipText("Valeur en degré celsius");
        champCelsius = new JTextField(15);
        labCelsius.setLabelFor(champCelsius);
        ligneCelsius.add(labCelsius);
        ligneCelsius.add(champCelsius);
        ligneCelsius.add(helpButtonCelsius);
        this.add(ligneCelsius);
        celsiusAFocus = true;
        champCelsius.addFocusListener(new EcouteurFocus(true));
        JPanel ligneFarenheit = new JPanel();
        ligneFarenheit.setLayout(new FlowLayout(FlowLayout.TRAILING));
        JButton helpButtonFarenheit = new JButton("?");
        try{
            helpButtonFarenheit.setIcon((Icon) new ImageIcon(new URL
                    ("https://www.google.com/url?sa=i&url=https%3A%2F%2Fwww.iconfinder.com%2Ficons%2F438977%2Fhelp_information_" +
                            "problem_query_question_mark_status_support_icon&psig=AOvVaw1cYXbJ9Vzj3U5xdNUTgNYK&ust=1586010833844000&" +
                            "source=images&cd=vfe&ved=0CAIQjRxqFwoTCMidpfi8zOgCFQAAAAAdAAAAABAP")).getImage());
        }catch (Exception e){}

        helpButtonFarenheit.addActionListener(a->{
            JFrame aide = new JFrame("Aide");
            JOptionPane.showMessageDialog(aide,"Valeur en Farenheit");
        });

        JLabel labFarenheit = new JLabel("Farenheit :");
        labFarenheit.setToolTipText("Valeur en farenheit");
        champFarenheit = new JTextField(15);
        labFarenheit.setLabelFor(champFarenheit);

        ligneFarenheit.add(labFarenheit);
        ligneFarenheit.add(champFarenheit);
        ligneFarenheit.add(helpButtonFarenheit);
        this.add(ligneFarenheit);
        champFarenheit.addFocusListener(new EcouteurFocus(false));
        JPanel ligneValider = new JPanel();
        ligneValider.setLayout(new FlowLayout(FlowLayout.CENTER));
        actionConvertir = new ActionConvertir();
        boutonConvertir = new JButton(actionConvertir);
        ligneValider.add(boutonConvertir);
        this.add(ligneValider);
        
        pack();
        getRootPane().setDefaultButton(boutonConvertir);
    }

    private class EcouteurFocus implements FocusListener {
        private boolean aStocker;

        public EcouteurFocus(boolean b) {
            aStocker = b;
        }

        @Override
        public void focusGained(FocusEvent fe) {
            celsiusAFocus = aStocker;
        }

        @Override
        public void focusLost(FocusEvent fe) {}
    }

    private class ActionConvertir extends AbstractAction {

        public ActionConvertir() {
            super("Convertir");
        }

        @Override
        public void actionPerformed(ActionEvent ae) {
            double tempCelsius = 0;
            double tempFarenheit = 0;
            if (celsiusAFocus) {
                try {
                    tempCelsius = Double.parseDouble(champCelsius.getText());
                tempFarenheit = 9./5*tempCelsius+32;
                champFarenheit.setText(""+tempFarenheit);
                }
                catch (NumberFormatException nfe) {
                    champFarenheit.setText("Format incorrect");
                }
                }
            else {
                try {
                    tempFarenheit = Double.parseDouble(champFarenheit.getText());
                    tempCelsius = (tempFarenheit - 32) *5./9;
                    champCelsius.setText(""+tempCelsius);
                }
                catch (NumberFormatException nfe) {
                    champCelsius.setText("Format incorrect");
                }
            }
        }
    }
}
